﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.01
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private B4XTable1     As B4XTable
	Private xui           As XUI
	Private Col_Socio     As B4XTableColumn
	Private Col_Cuenta    As B4XTableColumn
	Private Col_Ruta      As B4XTableColumn
	Private Col_Nombre    As B4XTableColumn
	Private Col_Calle     As B4XTableColumn
	Private Col_ENE_si    As B4XTableColumn
	Private Col_ENE_ant   As B4XTableColumn
	Private Col_ENE_act   As B4XTableColumn
	Private Col_ENE_pro   As B4XTableColumn
	Private Col_ENE_lectu As B4XTableColumn
	Private Col_Energia   As B4XTableColumn
	Private Col_AGU_si    As B4XTableColumn
	Private Col_AGU_ant   As B4XTableColumn
	Private Col_AGU_act   As B4XTableColumn
	Private Col_AGU_pro   As B4XTableColumn
	Private Col_AGU_lectu As B4XTableColumn
	Private Col_Agua      As B4XTableColumn
	Private Col_Notas     As B4XTableColumn
	Private btnPrev       As Button
	Private btnNext       As Button
	Private IME           As IME
	Private Dialog        As B4XDialog
	Private InputTemplate As B4XInputTemplate
End Sub

Sub Activity_Create(FirstTime As Boolean)
	IME.Initialize("ime")
	IME.AddHeightChangedEvent
	Activity.LoadLayout("2")
	Activity.Title = "Toma Estado"
	
	Dialog.Initialize(Activity)
	Dialog.Title = "Ingresar Toma Estado:"
	InputTemplate.Initialize
	
	If FirstTime = False Then
		ToastMessageShow("NO ES Primera vez",False)
		'ExportTableToCSV
	End If
	
	'Los colores por defecto de la tabla asumen un tema claro. Si usas un tema oscuro,
	'necesitamos hacer algunos cambios:
	'Sleep(0) 'Se requiere ya que las vistas no se cargan inmediatamente.
	
	'B4XTable1.ArrowsDisabledColor = xui.Color_Gray
	'B4XTable1.ArrowsEnabledColor = xui.Color_White
	'B4XTable1.lblNumber.TextColor = B4XTable1.ArrowsEnabledColor
	'B4XTable1.SearchField.HintColor = xui.Color_White 'requires XUI Views v1.86+
	'B4XTable1.SearchField.NonFocusedHintColor = xui.Color_White
	'B4XTable1.SearchField.Update

	'Creo todas las Columnas del archivo CSV (Deben crearse todas, sino da error)
	Col_Socio     = B4XTable1.AddColumn("Socio"    , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_Cuenta    = B4XTable1.AddColumn("Cuenta"   , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_Ruta      = B4XTable1.AddColumn("Ruta"     , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_Nombre    = B4XTable1.AddColumn("Nombre"   , B4XTable1.COLUMN_TYPE_TEXT)
	Col_Calle     = B4XTable1.AddColumn("Calle"    , B4XTable1.COLUMN_TYPE_TEXT)
	Col_ENE_si    = B4XTable1.AddColumn("ENE_si"   , B4XTable1.COLUMN_TYPE_TEXT)
	Col_ENE_ant   = B4XTable1.AddColumn("ENE_ant"  , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_ENE_act   = B4XTable1.AddColumn("Energía"  , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_ENE_pro   = B4XTable1.AddColumn("ENE_pro"  , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_ENE_lectu = B4XTable1.AddColumn("ENE_lectu", B4XTable1.COLUMN_TYPE_TEXT)
	Col_Energia   = B4XTable1.AddColumn("Energiax" , B4XTable1.COLUMN_TYPE_TEXT)
	Col_AGU_si    = B4XTable1.AddColumn("AGU_si"   , B4XTable1.COLUMN_TYPE_TEXT)
	Col_AGU_ant   = B4XTable1.AddColumn("AGU_ant"  , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_AGU_act   = B4XTable1.AddColumn("Agua"     , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_AGU_pro   = B4XTable1.AddColumn("AGU_pro"  , B4XTable1.COLUMN_TYPE_NUMBERS)
	Col_AGU_lectu = B4XTable1.AddColumn("AGU_lectu", B4XTable1.COLUMN_TYPE_TEXT)
	Col_Agua      = B4XTable1.AddColumn("Aguax"    , B4XTable1.COLUMN_TYPE_TEXT)
	Col_Notas     = B4XTable1.AddColumn("Notas"    , B4XTable1.COLUMN_TYPE_TEXT)
	
	'Le doy un formato Especial a la columna Numero
	CreateCustomFormat(Col_ENE_act)
	CreateCustomFormat(Col_AGU_act)
	
	'Cargando la data en B4XTable
	Dim su As StringUtils
	'Utilizo LoadCSV para cargar el CSV sin Cabecera
	Dim data As List = su.LoadCSV(File.DirAssets, "cargas.csv", ",")
	'Carga la lista al objeto B4XTable
	B4XTable1.SetData(data)
	
	'Quito la visualización de las columnas que no quiero mostrar
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Socio))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Ruta))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Calle))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_ENE_si))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_ENE_ant))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_ENE_pro))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_ENE_lectu))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Energia))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_AGU_si))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_AGU_ant))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_AGU_pro))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_AGU_lectu))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Agua))
	B4XTable1.VisibleColumns.RemoveAt(B4XTable1.VisibleColumns.IndexOf(Col_Notas))
	'B4XTable1.VisibleColumns.InsertAt(1, NumberColumn)  'y la muestra en segundo lugar

	'Les coloco un ancho personalizado a cada columna
	Col_Cuenta.Width  = 23.7%x
	Col_Nombre.Width  = 40.5%x
	Col_ENE_act.Width = 17.9%x
	Col_AGU_act.Width = 17.9%x
	B4XTable1.MaximumRowsPerPage = 10   'Limita a 10 registros por pagina
	B4XTable1.BuildLayoutsCache(10)     'Fuerza re-dibujar las celdas cuando cambia de tamaño la vista
	B4XTable1.Refresh
End Sub

Sub IME_HeightChanged (NewHeight As Int, OldHeight As Int)
	If B4XTable1.IsInitialized Then
		B4XTable1.mBase.Height = NewHeight - B4XTable1.mBase.Top
		B4XTable1.Refresh
	End If
End Sub

Sub B4XSwitch1_ValueChanged (Value As Boolean)
	If Value Then
		'Se crea un filtro personalizado
		B4XTable1.CreateDataView($"${Col_ENE_act.SQLID} > 0 or ${Col_AGU_act.SQLID} > 0"$)
	Else
		B4XTable1.ClearDataView
	End If
End Sub

Sub B4XTable1_CellClicked (ColumnId As String, RowId As Long)
	Dim RowData As Map = B4XTable1.GetRow(RowId)
	Dim cNombre As String = RowData.Get("Nombre")
	Dim cTipo   As String
	If ColumnId = "Energía" Then
		cTipo = " (Energía)"
	Else If ColumnId = "Agua" Then
		cTipo = " (Agua)"
	End If
	Activity.Title = cNombre & cTipo

	'Esto visualiza un mesanje temporal (corto) de lo seleccionado con un color especial
	Dim cs As CSBuilder
	cs.Initialize.Color(Colors.RGB(0,128,0)).Size(20).Bold.Append(cNombre & cTipo).PopAll
	ToastMessageShow(cs, False)
End Sub

Sub B4XTable1_CellLongClicked (ColumnId As String, RowId As Long)
	Dim column As B4XTableColumn = B4XTable1.GetColumn(ColumnId)
	Dim value As String = B4XTable1.GetRow(RowId).Get(ColumnId)
	If column.Id = "Energía" Or column.Id = "Agua" Then
		InputTemplate.Text = value
		InputTemplate.lblTitle.Text = column.Id
		Wait For (Dialog.ShowTemplate(InputTemplate, "Aceptar", "", "Cancelar")) Complete (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			B4XTable1.sql1.ExecNonQuery2($"UPDATE data SET ${column.SQLID} = ? WHERE rowid = ?"$, _
			Array As String (InputTemplate.Text, RowId))
			B4XTable1.Refresh
		End If
	End If
End Sub

Private Sub CreateCustomFormat (c As B4XTableColumn)
	Dim formatter As B4XFormatter
	formatter.Initialize
	c.Formatter = formatter
	Dim Positive As B4XFormatData = c.Formatter.NewFormatData
	Positive.TextColor = B4XTable1.TextColor
	Positive.FormatFont = xui.CreateDefaultBoldFont(16)
	c.Formatter.AddFormatData(Positive, 0, c.Formatter.MAX_VALUE, True) 'Inclusive (zero included)
	Dim Negative As B4XFormatData = c.Formatter.CopyFormatData(Positive)
	Negative.TextColor = xui.Color_Red
	Negative.FormatFont = xui.CreateDefaultBoldFont(14)
	Negative.Prefix = "("
	Negative.Postfix = ")"
	c.Formatter.AddFormatData(Negative,c.Formatter.MIN_VALUE, 0, False)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	ToastMessageShow("...Actualizando Toma Estado...", False)
	'If UserClosed Then ExportTableToCSV
	StartActivity(Main)
End Sub

Sub btnNext_Click
	B4XTable1.CurrentPage = B4XTable1.CurrentPage + 1
End Sub

Sub btnPrev_Click
	B4XTable1.CurrentPage = B4XTable1.CurrentPage - 1
End Sub

Sub B4XTable1_DataUpdated
	btnNext.Enabled = B4XTable1.lblNext.Tag
	btnPrev.Enabled = B4XTable1.lblBack.Tag
End Sub

Public Sub ExportTableToCSV
	Dim data As List
	data.Initialize
	Dim rs As ResultSet = B4XTable1.sql1.ExecQuery("SELECT * FROM data")
	Do While rs.NextRow
		Dim row(B4XTable1.Columns.Size) As String
		For i = 0 To B4XTable1.Columns.Size - 1
			Dim c As B4XTableColumn = B4XTable1.Columns.Get(i)
			row(i) = rs.GetString(c.SQLID)
		Next
		data.Add(row)
	Loop
	rs.Close
	Dim su As StringUtils
	su.SaveCSV(File.DirAssets, "cargas.csv", ",", data)
	'su.SaveCSV(File.DirRootExternal, "cargas.csv", ",", data)
End Sub
